	;;
	;; Beep out altitude
	;;
	;; Call with 16 bit binary number for altitude in BARGB0 and BARGB1
	;;
	include p16f628.inc
	include data.inc

	global	beep_alt
	extern	B2_BCD
	extern	beep_on, beep_short_pause, beep_long_pause
TICKRATE	equ	0x80
	code

beep_wait:
	btfss	TFLAG,0
	goto	beep_wait	; wait for timer tick
	bcf	TFLAG,0		; clear flag
	decfsz	BEEP_TICK,F
	goto	beep_wait
	return


beep_alt:
	;; Start with really long pause
	movlw	5
	movwf	LOOPCOUNT
wloop:	movlw	TICKRATE
	movwf	BEEP_TICK
	call	beep_wait
	decfsz	LOOPCOUNT,F
	goto	wloop

	;; First step is to convert to BCD
	call B2_BCD
	;; BCD number is now in AARG
	;;
	;; Unpack the BCD characters, one per byte
	;;

	movf	AARGB2,W
	andlw	0x0f
	movwf	AARGB4
	swapf	AARGB2,W
	andlw	0x0f
	movwf	AARGB3
	movf	AARGB1,W
	andlw	0x0f
	movwf	AARGB2
	swapf	AARGB1,W
	andlw	0x0f
	movwf	AARGB1
	movf	AARGB0,W
	andlw	0x0f
	movwf	AARGB0


	;;
	;; SKip leading zeros
	;;
	movlw	AARGB0
	movwf	FSR
	movf	INDF,F
	btfss	STATUS,Z
	decf	FSR,F
	btfss	STATUS,Z
	goto	digit_loop		; first digit is non-zero
	
	incf	FSR,F		; check second digit
	movf	INDF,F
	btfss	STATUS,Z
	decf	FSR,F
	btfss	STATUS,Z
	goto	digit_loop		; second digit is non-zero
	
	incf	FSR,F		; check third digit
	movf	INDF,F
	btfss	STATUS,Z
	decf	FSR,F
	btfss	STATUS,Z
	goto	digit_loop		; third digit is non-zero
	
	incf	FSR,F		; check fourth digit
	movf	INDF,F
	btfss	STATUS,Z
	decf	FSR,F
	btfss	STATUS,Z
	goto	digit_loop		; fourth digit is non-zero


	;;
	;; Even if fifth digit is zero, do it anyway!
	;;

digit_loop:
	incf	FSR,F
	movf	FSR,W
	xorlw	AARGB5		; see if done
	btfsc	STATUS,Z
	return
	movf	INDF,W		; get digit
	btfsc	STATUS,Z	; zero is a special case
	goto	do_zero
beep_loop:	
	call	beep_on
	call	beep_wait
	call	beep_short_pause
	call	beep_wait
	decf	INDF,F
	btfss	STATUS,Z
	goto	beep_loop
	call	beep_long_pause	; between digits pause
	call	beep_wait
	goto	digit_loop
	;;
	;; zero is a special case since we need to change frequency
	;; 
do_zero:	
	movlw	0xff		; make frequency as low as possible (~1KHz)
	bsf	STATUS,RP0
	movwf	PR2
	bcf	STATUS,RP0

zbeep_loop:	
	call	beep_on
	movlw	TICKRATE/2	; longer than normal beep
	movwf	BEEP_TICK
	call	beep_wait
	call	beep_long_pause	; between digits pause
	call	beep_wait

	movlw	0x3d		; return frequency to normal
	bsf	STATUS,RP0
	movwf	PR2
	bcf	STATUS,RP0
	goto	digit_loop
	end
